package examples;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.LinkedList;
import java.util.List;

import libHamCast.HamcastUtility;
import libHamCast.Log;
import libHamCast.MulticastSocket;
import multicastApi.GroupSet;
import multicastApi.NetworkMInterface;

public class Hc_status_java {

	//test some utility and socket functions.

	
	public static void main(String[] args) {

		
		InputStreamReader istream = new InputStreamReader(System.in) ;
		BufferedReader bufRead = new BufferedReader(istream) ;
		List<String> uris=new LinkedList<String>();
		String end="b";
		MulticastSocket socket=null;
		try {
			socket=new MulticastSocket();
		} catch (IOException e1) {
			System.out.println("Error: "+e1.getMessage());
		}
		//getting uris
		while(!(end.equals("f")))
		{
			System.out.println("Insert one group uri and press enter\ninsert \"f\" if you finished:");
			try {
				end=(bufRead.readLine());
				if(!end.equals("f")) uris.add(end);
				
			} catch (IOException e) {
				System.out.println("could'nt read your input, try again:");
			}
				
		}
		
		//joining groups
		if(socket!=null){
			System.out.println("Joining groups...");

			if(!uris.isEmpty()){
				for( String str:uris){
					try {
						
						socket.join(str);
					} catch (URISyntaxException e) {
						System.out.println("uri-exception-uri wasn't right");
					} catch (IOException e) {
						System.out.println("Error Cause: "+ e.getCause());
						System.out.println("Error Message: "+ e.getMessage());
					}
			}
			}
		} else System.out.println("Socket was null, so joining is no option...");
		List<NetworkMInterface> iList=null;
		System.out.println("Fetching available interfaces...");
		try {
			iList=HamcastUtility.getAllInterfaces();
			for(NetworkMInterface mi:iList){
				System.out.println("Display name: "+mi.getDisplayName());
				System.out.println("Index: "+mi.getIndex());
				System.out.println("InetAdress: "+mi.getInetAddress());
				System.out.println("Technology: "+mi.getTech());
			}
		} catch (IOException e) {
			System.out.println("Error Cause: "+ e.getCause());
			System.out.println("Error Message: "+ e.getMessage());
		}
		
		
		if(iList!=null){
			System.out.println("Now lets look for some groups...");
			
				for(NetworkMInterface mi:iList){
					
					try {
						if(!uris.isEmpty()){List<GroupSet> gs=HamcastUtility.groupSet(mi);
						System.out.println(mi.getDisplayName()+":");
						if(!gs.isEmpty()){
							for(GroupSet gss:gs){
								System.out.println("uri: "+gss.getUri());
								System.out.println("type: "+gss.getType());
							List<URI> gsss=HamcastUtility.parentSet(mi, gss.getUri());	
							}	
						}
						}
					} catch (IOException e) {
						System.out.println("Error cause: "+e.getCause());
						System.out.println("Error- Message: "+e.getMessage());
					}
				}
		}
		
		//changing the default exception handler
		HamcastUtility.setExceptionHandler(new Runnable() {
			
			@Override
			public void run() {
				System.out.println("your exception handling as you like it.");
				
			}
			@Override
			public String toString(){
				return "your handler";
			}
		});
		
		System.out.println("Exceptionhandler: "+HamcastUtility.getExceptionHandler());
		
		

	}
	
	


}
